%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitgewichtete Betragsregelflche ISTAE
%optimierung_ISTAE_parabel.m
%Eingangsgre Parabelfunktion

clear, clf, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = 0:delta_t:tmax; tt = (t .* t)';
w = (t .* t / 2.0)'; nmax = 8; dfa = 1.0e-4; df_min = 0.75e-4;

berechne = 1; n = 3; %Ergebnisse
A_ISTAE = 7.309338421945325; f1m = 2.3699; f2m = 2.0475;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ISTAE_p(n) = tf([f2 f1 1], [1 f2 f1 1]);
        x = lsim(G_ISTAE_p(n), w, t);
        A = delta_t * trapz(tt .* abs(w - x));
        if A_min > A + eps
           A_min = A; anz_min = anz_min + 1; f1_min = f1; f2_min = f2;
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, f1m = f1_min, f2m = f2_min,
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf([f2m f1m 1], [1 f2m f1m 1]);

berechne = 0; n = 4; %Ergebnisse
A_ISTAE =  19.132026788356402;
f1m =  2.7134; f2m =  3.6103; f3m =  2.0349;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1;
while anz_min > 0 
    anz_min = 0; j = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df
            G_ISTAE_p(n) = tf ([f2 f1 1], [1 f3 f2 f1 1]);
            x = lsim(G_ISTAE_p(n), w, t);
            A = delta_t * trapz(tt .* abs(w - x));
            if A_min > A + eps
               A_min = A; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, 
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf ([f2m f1m 1], [1 f3m f2m f1m 1]);

berechne = 0; n = 5; %Ergebnisse
A_ISTAE =  55.053696554769907;
f1m = 3.4342; f2m = 5.0511; f3m = 4.8573; f4m = 2.3624;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                G_ISTAE_p(n) = tf ([f2 f1 1], [1 f4 f3 f2 f1 1]);
                x = lsim(G_ISTAE_p(n), w, t);
                A = delta_t * trapz(tt .* abs(w - x));
                if A_min > A
                   A_min = A; anz_min = anz_min + 1;
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf ([f2m f1m 1], [1 f4m f3m f2m f1m 1]);

berechne = 0; n = 6; %Ergebnisse
A_ISTAE = 1.072216288020736e+002; f1m = 3.8558; f2m = 7.3157;
f3m = 7.4897; f4m = 6.0389; f5m = 2.3515;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ISTAE_p(n) = tf ([f2 f1 1], [1 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ISTAE_p(n), w, t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min, 
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min 
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf ([f2m f1m 1], [1 f5m f4m f3m f2m f1m 1]);
 
berechne = 0; n = 7; %Ergebnisse
A_ISTAE = 2.132247351056924e+002;
f1m =  4.5064; f2m = 9.2652; f3m = 12.5301;
f4m = 10.4926; f5m = 7.2560; f6m =  2.5819;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ISTAE_p(n) = tf ([f2 f1 1], [1 f6 f5 f4 f3 f2 f1 1]);
                    x = lsim(G_ISTAE_p(n), w, t);
                    A = delta_t * trapz(tt .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf ([f2m f1m 1], [1 f6m f5m f4m f3m f2m f1m 1]);

berechne = 0; n = 8; %Ergebnisse
A_ISTAE = 3.612769209881175e+002;
f1m =  4.9608; f2m = 12.1038; f3m = 17.4005; f4m = 19.0981;
f5m = 13.1356; f6m =  8.3636; f7m =  2.5374;

%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
f1    
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                for f6 = f6m-df:df:f6m+df
                for f7 = f7m-df:df:f7m+df
                G_ISTAE_p(n) = tf ([f2 f1 1], [1 f7 f6 f5 f4 f3 f2 f1 1]);
                x = lsim(G_ISTAE_p(n), w, t);
                A = delta_t * trapz(tt .* abs(w - x));
                if A_min > A + eps
                   A_min = A; anz_min = anz_min + 1; 
                   f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                   f5_min = f5; f6_min = f6; f7_min = f7;
                end
                end
                end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ISTAE = A_min,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ISTAE_p(n) = tf ([f2m f1m 1], [1 f7m f6m f5m f4m f3m f2m f1m 1]);

t = 0:10.0*delta_t:8.0; w = (t .* t / 2.0)';
subplot(121)
hold off
for n = 3:nmax
        x = lsim(G_ISTAE_p(n), w, t);
        plot(t, x), hold on, grid on
end
plot(t, w, 'k:')
title('ISTAE-Optimierung des Beschleunigungsfehlers')
xlabel('Zeit t / s'), ylabel('Parabelantwort x(t)')
axis ([0 7.5 -0.55 25])

subplot (122)
hold off
for n = 3:nmax
        x = lsim(G_ISTAE_p(n), w, t);
        plot(t, (w - x)), hold on, grid on
end
title('fr w(t) = t^2/2, \omega_k = 1 s^-^1')
xlabel('Zeit t / s'), ylabel('Regeldifferenz x_d(t) = w(t) - x(t)')
axis ([0 7.5 -0.1 5.2])


