%MATLAB Script-File re_zeit_162.m
%Ermittlung von Rechenzeiten
clear
n=5000000;

%Programm mit for-Schleife
t01=cputime;            %Rechenzeit
k=1;
for x=0:2*pi/n:2*pi;
    y(k)=cos(x);
    k=k+1;
end
t0=cputime-t01          %Zeitdifferenz

%Programm mit for-Schleife
%und preallocation fr y
t02=cputime;
y=zeros(1,n);           %Vordefinition Vektor y mit Null
k=1;
for x=0:2*pi/n:2*pi;
    y(k)=cos(x);
    k=k+1;
end
t1=cputime-t02

%Programm in Vektorschreibweise
t03=cputime;
x=0:2*pi/n:2*pi;
y=cos(x);
t2=cputime-t03
