%MATLAB Script-File sf_plan2_164.m
%Signalflussplan fr eine Kaskadenregelung

num1=4; den1=1;     G1=tf(num1,den1); %Zhlerpolynome (numi)
num2=3; den2=1;     G2=tf(num2,den2); %und
num3=2; den3=1;     G3=tf(num3,den3); %Nennerpolynome (deni)
num4=1; den4=1;     G4=tf(num4,den4); %sowie
num5=5; den5=[1 2]; G5=tf(num5,den5); %die
num6=1; den6=[1 1]; G6=tf(num6,den6); %Teilbertragungs-
num7=1; den7=[1 0]; G7=tf(num7,den7); %funktionen
num8=4; den8=1;     G8=tf(num8,den8); %G1(s) bis G8(s)

Gi=append(G1,G2,G3,G4,G5,G6,G7,G8); %Blockbildung

q=[1  0  0  0  0  0  0  0     %Die Matrix q beschreibt den Signal-
   2  1 -8  0  0  0  0  0     %fluss im Signalflussbild. In der 1. 
   3  2 -6  0  0  0  0  0     %Spalte steht die Nr. des bertra-
   4  3 -5  0  0  0  0  0     %gungsblocks. In den folgenden Spal- 
   5  4  0  0  0  0  0  0     %ten stehen die Blcke, deren Aus-
   6  5  0  0  0  0  0  0     %gang mit dem Eingang des Blocks in
   7  6  0  0  0  0  0  0     %der 1. Spalte verbunden ist. Bei-
   8  7  0  0  0  0  0  0];   %spiel Zeile 2: Der Eingang von
                              %Block 2 ist mit den Ausgngen der
         				      %Blcke 1 und 8 verbunden.
               			      %Matrix q ist quadratisch.
Fuehrung=1;  				  %Fhrungsgre wirkt auf Block 1
Ausgang=7;					  %Regelgre kommt von Block 7
Fsys=connect(Gi,q,Fuehrung,Ausgang); 	%Zustandsdarstellung
fprintf('\n')         		  %neue Zeile
disp('Fhrungsbertragungsfunktion:')
G=tf(Fsys)				 	  %Fhrungsbertragungsfunktion G(s)
Stoerung=5;           		  %Strgre wirkt auf Block 5
Zsys=connect(Gi,q,Stoerung,Ausgang); 	%Zustandsdarstellung
fprintf('\n')
disp('Strungsbertragungsfunktion:')
Gz=tf(Zsys) 			 	  %Strungsbertragungsfunktion Gz(s)
